<?php // File: $Id: gallery_random.php,v 0.41 2002/10/16 18:00:00 joehoz Exp $
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2001 by the Post-Nuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// Based on:
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: adam_baum w/Patrick's help ;)
// Based on: Bharat Medirattas random block
// Modified to fit in PN: Joerg Holzapfel (j.holzapfel@web.de)
// Purpose of file: display random picture from gallery.
// ----------------------------------------------------------------------
// History:
// 2002/08/10	Edited Bharats block to fit in PN 0.7*
// 2002/08/11	Applied some fixes found at different locations
// 2002/09/04	Disabled sessioning because this was 
//		causing an error in session.php (Line 55) in gallery 1.3.1
//
// 2002/10/13	Added thumb resizing		
// 2002/10/16	Fixed "cannot redeclare function" error

$blocks_modules['gallery_random'] = array(
    'func_display' => 'blocks_gallery_random_block',
    'func_edit' => 'blocks_gallery_random_edit',
    'func_update' => 'blocks_gallery_random_update',
    'func_add' => 'blocks_gallery_random_add',
    'text_type' => 'gallery_random',
    'text_type_long' => 'gallery Random Picture',
    'allow_multiple' => true,
    'form_content' => false,
    'form_refresh' => false,
    'show_preview' => true
);

// Mainfunction
function blocks_gallery_random_block($row)
{

    global $GALLERY_NO_SESSIONS;
    global $GALLERY_BASEDIR;
    global $GALLERY_EMBEDDED_INSIDE;
    global $GALLERY_MODULENAME;
    global $op;
    global $mop;
    global $include;
    global $name;

    $GALLERY_MODULENAME = "gallery"; //Change this to your module Name
    $GALLERY_BASEDIR = "modules/$GALLERY_MODULENAME/";
    $GALLERY_EMBEDDED_INSIDE = "nuke";
    $GALLERY_NO_SESSIONS = true;

    // Rogue Permission 
    pnSecAddSchema('gallery_random_block::', 'Block title::');

    // Hack prevention.
    if (!empty($HTTP_GET_VARS["GALLERY_BASEDIR"]) ||
			!empty($HTTP_POST_VARS["GALLERY_BASEDIR"]) ||
			!empty($HTTP_COOKIE_VARS["GALLERY_BASEDIR"])) {
	print "Security violation\n";
	exit;
    }

    require_once($GALLERY_BASEDIR . "init.php");
    if (!$gallery->app->albumDir) {
	include($GALLERY_BASEDIR . "config.php");
    }

    //check for Rogue Permission
    if (!pnSecAuthAction(0, 'gallery_random_block::', "$row[title]::", ACCESS_READ))   { return; }

    $vars = getVarsFrom_gallery_random_Content($row);
    $row['content'] = "";
    
    // Thumbwitdh
    $tmbwidth = $vars['tmbwidth'];
    // Thumbheight
    $tmbheight = $vars['tmbheight'];
    // Save aspect ratio
    $svaspect = $vars['svaspect'];
    // Don't do any resize
    $uresize = $vars['uresize'];
    // Enclavar album
    $clavalbum = $vars['clavalbum'];
    $row['content'] = "";

    if ($profile) {
	$timer = time();
    }

    /* Initializing the seed */
    srand ((double) microtime() * 1000000);

    define(CACHE_FILE, $gallery->app->albumDir . "/block-random.cache");
    define(CACHE_EXPIRED, 86400);
    
    // Check the cache file to see if it's up to date
    $rebuild = 1;
    if (fs_file_exists(CACHE_FILE)) {
	$stat = fs_stat(CACHE_FILE);
	$mtime = $stat[9];
	if (time() - $mtime < CACHE_EXPIRED) {
		$rebuild = 0;
	}
    }

    if ($rebuild) {
	scanAlbums();
	saveCache();
    } else {
	readCache();
    }

    $album = chooseAlbum($clavalbum);

    if ($album) {
	$index = choosePhoto($album);
    }

    if (isset($index)) {
	$id = $album->getPhotoId($index);
	
	// Resize thumb when resizing is selected
	if ($uresize != 0) {
		$tmbTag = tmbresizeTag($album, $index, $tmbwidth, $tmbheight, $svaspect);
	} else {
		$tmbTag = $album->getThumbnailTag($index);
	}
	
	$row['content'] =  ""
	        ."<center><a href=" .makeAlbumUrl($album->fields["name"], $id) .">"
		.$tmbTag
		."</a></center>";
    
	$caption = $album->getCaption($index);
	if ($caption) {
	    $row['content'] .= "<br><center>$caption</center>";
	}
    
	$row['content'] .= "<br><center>Album: "
	        ."<a href=" .makeAlbumUrl($album->fields["name"]) .">"
		.$album->fields["title"]
		."</a></center>";
    } else {
		print "No photo chosen.";
    }

    if ($profile) {
	$elapsed = time() - $timer;
	print "<br>Elapsed: $elapsed secs";
    }
    
    
    themesideblock($row);
}

function blocks_gallery_random_add($row)
{
    $row['content']="tmbwidth=150\ntmbheight=113\nsvaspect=0\uresize=0\n";
    return $row;
}


function blocks_gallery_random_update($row)
{
    global $HTTP_POST_VARS;
    $row['content']="tmbwidth=".$HTTP_POST_VARS['tmbwidth']."\ntmbheight=".$HTTP_POST_VARS['tmbheight']."\nsvaspect=".$HTTP_POST_VARS['svaspect']."\nuresize=".$HTTP_POST_VARS['uresize']."\nclavalbum=".$HTTP_POST_VARS['clavalbum']."\n";
    return($row);
}


function blocks_gallery_random_edit($row)
{
    // Break out options from our content field
    $vars = getVarsFrom_gallery_random_Content($row);
                
    // Parameters for block parts. Part will not be shown if zero
    $output = "<tr><td class=\"pn-normal\">". "Width of thumb (px): " .":</td><td><input type=\"text\" name=\"tmbwidth\" size=\"4\" value=\"$vars[tmbwidth]\"></td></tr>";
    $output .= "<tr><td class=\"pn-normal\">". "Height of thumb (px): " .":</td><td><input type=\"text\" name=\"tmbheight\" size=\"4\" value=\"$vars[tmbheight]\"></td></tr>";
    $output .= "<tr><td class=\"pn-normal\">". "Save aspect ratio (0=no/1=yes): " .":</td><td><input type=\"text\" name=\"svaspect\" size=\"1\" value=\"$vars[svaspect]\"></td></tr>";
    $output .= "<tr><td class=\"pn-normal\">". "Use resize (0=no/1=yes): " .":</td><td><input type=\"text\" name=\"uresize\" size=\"1\" value=\"$vars[uresize]\"></td></tr>";
    $output .= "<tr><td class=\"pn-normal\">". "Enclavar album (album01, album02, ...): " .":</td><td><input type=\"text\" name=\"clavalbum\" size=\"7\" value=\"$vars[clavalbum]\"></td></tr>";

    return $output;
}
                                    
////
// Get variables from content
// Format of variables:
// name=val
// name=val
////

function getVarsFrom_gallery_random_Content($row){
    $links = explode("\n", $row['content']);
    $vars = array();
    foreach ($links as $link) {
	$link = trim($link);
	if ($link) 
	{
	$var = explode("=", $link);
        $vars = array_merge($vars, array($var[0] => $var[1]));
	}
    }
    // Defaults
    if (!isset($vars['tmbwidth']))
    {
	$vars['tmbwidth'] = 150;
    }
    if (!isset($vars['tmbheight']))
    {
	$vars['tmbheight'] = 113;
    }
    if (!isset($vars['svaspect']) OR (empty($vars['svaspect'])))
    {
	$vars['svaspect'] = 0;
    }
    if (!isset($vars['uresize']) OR (empty($vars['uresize'])))
    {
	$vars['uresize'] = 0;
    }
    if (!isset($vars['clavalbum']) OR (empty($vars['clavalbum'])))
    {
	$vars['clavalbum'] = "ninguno";
    }

    return($vars);
}

                                                                                                                       
/*
 * --------------------------------------------------
 * Support functions (gallery)
 * --------------------------------------------------
 */

function tmbresizeTag($album, $index, $tmbwidth, $tmbheight, $svaspect) {
    $tmbTagDetails = explode(" ", $album->getThumbnailTag($index));
    $tmbURL = trim($tmbTagDetails[1]);
    $tmbBorder = trim($tmbTagDetails[5]);
    if ($svaspect != 0) {
	$tmbDimensions = $album->getThumbDimensions($index);
	//Original aspect
	$tmbratio = $tmbDimensions[0] / $tmbDimensions[1];
		
	// Height is set
	if ( ($tmbwidth == 0) AND ($tmbheight != 0) ) {
	    $tmbwidth = round($tmbheight * $tmbratio);
	}
		
	// Width is set
	if ( ($tmbwidth != 0) AND ($tmbheight == 0) ) {
	    $tmbheight = round($tmbwidth / $tmbratio);
	}
		
	$tmboutput = "<img $tmbURL width=$tmbwidth height=$tmbheight $tmbBorder";
    } else {
	$tmboutput = "<img $tmbURL width=$tmbwidth height=$tmbheight $tmbBorder";
    }
    return $tmboutput;	
}


function saveCache() {
    global $cache;
    if ($fd = fs_fopen(CACHE_FILE, "w")) {
	foreach ($cache as $key => $val) {
	    fwrite($fd, "$key/$val\n");
	}
	fclose($fd);
    }
}

function readCache() {
    global $cache;
    if ($fd = fs_fopen(CACHE_FILE, "r")) {
	while ($line = fgets($fd, 4096)) {
	    list($key, $val) = explode("/", trim($line)); //trim-Fix from Mailing-List
	    $cache[$key] = $val;
	}
	fclose($fd);
    }
}

function choosePhoto($album) {
    global $cache;

    $count = $cache[$album->fields["name"]];
    if ($count == 0) {
	// Shouldn't happen
	return null;
    } else if ($count == 1) {
	$choose = 1;
    } else {
	$choose = rand(1, $count);
	$wrap = 0;
	if ($album->isHidden($choose)) {
	    $choose++;
	    if ($choose > $album->numPhotos(1)) {
		$choose = 1;
		$wrap++;

		if ($wrap = 2) {
		    return null;
		}
	    }
	}
    }

    return $choose;
}

function chooseAlbum($clavalbum) {
    global $cache;

    /*
     * The odds that an album will be selected is proportional
     * to the number of (visible) items in the album.
     */

    $total = 0;
    foreach ($cache as $name => $count) {
	if (!$choose) {
	    $choose = $name;
	}
	
	$total += $count;
	if ($total != 0 && ($total == 1 || rand(1, $total) <= $count)) {
	    $choose = $name;
	}
    }
    if ("$clavalbum" != "ninguno"){
        $choose = $clavalbum;
        }
    if ($choose) {
	$album = new Album();
	$album->load($choose);
	return $album;
    } else {
	return null;
    }
}

function scanAlbums() {
    global $cache;
    global $gallery;

    $cache = array();
    $everybody = $gallery->userDB->getEverybody();
    $albumDB = new AlbumDB();
    foreach ($albumDB->albumList as $tmpAlbum) {
	if ($everybody->canReadAlbum($tmpAlbum)) {
	    $seeHidden = $everybody->canWriteToAlbum($tmpAlbum);
	    $numPhotos = $tmpAlbum->numPhotos($seeHidden);
	    $name = $tmpAlbum->fields["name"];
	    if ($numPhotos > 0) {
		$cache[$name] = $numPhotos;
	    }
	}
    }
}


?>
